% Parameterfiles fuer das Simulink Modell des elektrischen Systems 
% (Aufgabe 1.4 und 1.5)
close all;
clear all;
clc;


% Widerstaende R1 und R2
R1 = 600;    % Widerstand in Ohm
R2 = 3500;   % Widerstand in Ohm

% Widerstandsverhaeltnis R4
K = 3;        % Spannungsverstrkung

% Kapazitaeten C1 und C2
C1_ref  = 9e-6;   % Referenz-Kapazittswert auf Kennlinie von C1 in F
C1_inf  = 1e-9;   % Referenz-Kapazittswert auf Kennlinie von C1 in F
UC1_ref = 3.5;      % Referenz-Spannungswert auf Kennlinie von C1 in V
C2      = 1e-6;   % Kapazitt in F

% Struktur zur Uebergabe der Variablen
p.R1 = R1;
p.R2 = R2;
p.K = K;
p.C1_ref  = C1_ref;
p.C1_inf  = C1_inf;
p.UC1_ref = UC1_ref;
p.C2      = C2;

% Festlegung der Ruhelage in Volt
UeR = 5;
UsR = 5;


%% Modell des linearisierten Systems

% Aufgabe 1.4.4
% -------------
% Errechnen Sie die Ruhelage des Systems!
UC1R = ;
UC2R = ;
UaR  = ;

% Errechnen Sie fr die gegebene Ruhelage die Ableitungen der in C1 
% gespeicherter Ladung Q1 nach der anliegenden Spannung!
dQ1  = ;  % Erste Ableitung von Q1 nach UC1
ddQ1 = ;       % Zweite Ableitung von Q1 nach UC1

% Ergaenzen Sie die Systemmatrix A (Asys), die Eingangsvektoren bu (busys)
% und bd (bdsys) sowie den Ausgangsvektor c (csys) und den Durchgriff d (dsys)
% fr das linearisierte System!
A11 = ;
A12 = ;
A21 = ;
A22 = ;

A  = [A11,A12;A21,A22];
bu = [];
bd = [];
c  = [];
du = [];
dd = [];

%% Uebertragungsfunktion G (Eingang u -> Ausgang y) und Uebertragungsfunktion Gd (Stoerung d -> Ausgang y)

% Aufgabe 1.4.4
% -------------
% Bestimmen Sie zunchst eine MISO- oder zwei SISO-Zustandsraum- 
% darstellungen mittels ss(). Anschlieend koennen Sie in beiden Faellen
% die gesuchten bertragungsfunktionen (G und Gd) mittels tf() bestimmen.

G  = ;
Gd = ;

%% Verstaerkungsfaktor V, Daempfungsgrad xi und Zeitkonstante T von G

% Aufgabe 1.4.5
% -------------
% Bestimmen Sie den Verstaerkungsfaktor V, den Daempfungsgrad xi und die
% Zeitkonstante T der bertragungsfunktion G. 

V  = ;
T  = ;
xi = ;

%% Bodediagramme der Uebertragungsfunktionen G und Gd

% Aufgabe 1.4.6
% -------------
% Zeichnen und interpretieren Sie die Bodediagramme der beiden
% Uebertragungsfunktionen G und Gd. Verwenden Sie dazu den Befehl bode().
%% Eingangsspannung und Stoerspannung (Aufgabe 1.5)
% Sprungfoermige Eingangsspannung
te = 0.01;      % Einschaltzeitpunkt in Sekunden
Ue = 1;      % Endwert des Sprunges in Volt

% Sinusfoermige Eingangsspannung
Usinus = 1; % Amplitude des Sinus in Volt
we     = 1e2;  % Winkelfrequenz des Sinus in rad/s

% Sprungfoermige Stoerspannung
ts = 0.03;     % Einschaltzeitpunkt in Sekunden
Us = 4;     % Endwert des Sprunges in Volt
